#!/bin/bash

if [ "`uname`" != "Linux" ]; then
	echo "error: Unknown OS detected"
	return 1;
fi

mkopci_mod=""
uname -r | grep -q "^2.4"
if [ "$?" = "0" ]; then
	mkopci_mod="mkopci.o"
else
	mkopci_mod="mkopci.ko"
fi

if [ $# = 1 ]; then
	mkopci_mod="$1/$mkopci_mod"
fi

bit=0
machine="`uname -m`"
echo $machine | grep -q "i.86"
if [ "$?" = 0 ]; then
	machine="i386"
	bit=32
else
	case "$machine" in
		"x86_64" ) bit=64 ;;
	esac
fi

if [ "x`lsmod | grep mkopci`" = "x" ]; then
	sudo insmod $mkopci_mod
fi

n=`cat /proc/mkopci/devices | grep "/dev/mkopci" | wc -l`
echo "Using $mkopci_mod for $n device(s)"

words=$(($bit/4))
for n in `seq 1 $n`; do
	echo "Test for card #$n"
	i=0
	for i in `seq 0 4`; do
		sudo insmod $mkopci_mod v=1 plx9050bug_quirk=0 > /dev/null 2>&1
#		sleep 0.1
		mem0=`head -n$((15*$n+$n+1)) /proc/mkopci/devices | tail -n15 | grep "mem_base\[${i}\] =" | awk -v w=$words '{ printf substr($6, 3, w); }'`;
		sudo rmmod mkopci;
		echo -n "Testing for BAR${i} ($mem0)... "
		k=0;
		while true; do 
			sudo insmod $mkopci_mod v=1 plx9050bug_quirk=$((${RANDOM} % 5))
			if [ "$?" != "0" ]; then
				echo "Error while insterting module";
				break;
			fi
#			sleep 0.1
			mem=`head -n$((15*$n+$n+1)) /proc/mkopci/devices | tail -n15 | grep "mem_base\[${i}\] =" | awk -v w=$words '{ printf substr($6, 3, w); }'`;
			[ "$mem" = "$mem0" ] && break;
			sudo rmmod mkopci; 
			k=$((k+1));
		done;
		[ "$?" = "0" ] && echo OK
		sudo rmmod mkopci
	done
	echo
done
sudo insmod $mkopci_mod

